# Proximity Voice Chat in GTFO
This is a mod I developed for use in [my videos](https://youtube.com/@PerfectMachine/). In the latest update, I added the ability to wake up sleepers via talking in [Mumble](https://www.mumble.info/). 👀

The setup process is lengthy and tedious but I genuinely think it pays off. I spent a lot of time on making sure nobody is confused anywhere through the process so you can either use the [Wiki](https://github.com/WWYDF/OpenPA/wiki) to walk you through it, or you can watch the [video tutorial](https://youtu.be/mMbHiqQQSqk?t=0) below. ❤️

## Table of Contents:
- [Installation Guide](https://github.com/WWYDF/OpenPA/wiki/Installation:-Mod-Manager)
  - [Video Tutorial](https://youtu.be/mMbHiqQQSqk?t=27)
- [Mumble Client Setup](https://github.com/WWYDF/OpenPA/wiki/Configuring-Mumble)
  - [First Time Setup](https://github.com/WWYDF/OpenPA/wiki/Setting-Up-Mumble#installation) (If you don't have Mumble, start here.)
  - [Recommended Settings](https://github.com/WWYDF/OpenPA/wiki/Configuring-Mumble#positional-audio-settings-%EF%B8%8F)
  - [TalkState Setup](https://github.com/WWYDF/TalkState#installation-guide) **NEW!**
- [Connecting to Mumble](https://github.com/WWYDF/OpenPA/wiki/Connecting-to-a-Mumble-Server)
- [Known Issues](https://github.com/WWYDF/OpenPA/wiki/Known-Issues)
- [Developer Tools](https://github.com/WWYDF/OpenPA/wiki/Developer-Tools)


## Installation Guide

You can find a full installation guide on the wiki.
https://github.com/WWYDF/OpenPA/wiki.

As well as a full video here:

[![click here for video](https://i.imgur.com/5mdVBjB.jpeg)](https://youtu.be/mMbHiqQQSqk?t=27)

## Special Thanks:
[Josh Robson Chase](https://gitlab.com/jrobsonchase) for his [Positional Voice Debugger](https://gitlab.com/jrobsonchase/mumble-position-debug) and [Valheim Mod Base](https://gitlab.com/jrobsonchase/valheimpositionalaudio) as well as his [explanation of the whole thing](https://josh.robsonchase.com/valheim-mumble/). Seriously wouldn't have created this without his work.

[GTFO Modding Team](https://discord.gg/gtfo-modding-server-782438773690597389) & [BepInEx](https://docs.bepinex.dev/) for putting together the [BepInEx Pack for GTFO](https://gtfo.thunderstore.io/package/BepInEx/BepInExPack_GTFO/) as well as the [Quickstart Guide](https://gtfo-modding.gitbook.io/wiki/) for Modding GTFO!


# Patch Notes
You can download development versions before they're available here on our [GitHub](https://github.com/WWYDF/OpenPA/releases).

- **2.0.0**
    - Added [TalkState](https://github.com/WWYDF/TalkState) integration to wake sleepers.
    - Added Steam Networking Events for Data Transmission.
    - Added config options.
      - TalkState: Enabled/Disabled
      - Refresh Rate: 120ms
      - Verbose: Enabled/Disabled
    - Added check to make sure PlayerAgent exists before using it.
    - Fixed crashing when a player joins after the game started.
- 1.2.0:
    - Initial release on **Thunderstore**.
    - Added support for drop-in Multiplayer.
    - Added config options for future features.
- 1.1.1:
    - Fixed polling rate bug in last release.
- 1.1.0:
    - Game no longer crashes upon leaving an expedition.
    - Link no longer drops upon entering sand dimension.
- 1.0.0:
    - Initial release on **GitHub**.